(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/material/core'), require('@angular/material/form-field'), require('@webacad/ng-codemirror'), require('rxjs'), require('codemirror')) :
	typeof define === 'function' && define.amd ? define('@webacad/ng-mat-codemirror', ['exports', '@angular/core', '@angular/forms', '@angular/material/core', '@angular/material/form-field', '@webacad/ng-codemirror', 'rxjs', 'codemirror'], factory) :
	(factory((global.webacad = global.webacad || {}, global.webacad['ng-mat-codemirror'] = {}),global.ng.core,global.ng.forms,global.ng.material.core,global.ng.material['form-field'],global.ngCodemirror,global.rxjs));
}(this, (function (exports,core,forms,core$1,formField,ngCodemirror,rxjs) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */
var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var nextUniqueId = 0;
var MatCodemirrorComponent = /** @class */ (function (_super) {
    __extends(MatCodemirrorComponent, _super);
    function MatCodemirrorComponent(el, _defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl, defaults) {
        var _this = _super.call(this, el, defaults) || this;
        _this._defaultErrorStateMatcher = _defaultErrorStateMatcher;
        _this._parentForm = _parentForm;
        _this._parentFormGroup = _parentFormGroup;
        _this.ngControl = ngControl;
        _this.required = false;
        _this.errorState = false;
        _this.stateChanges = new rxjs.Subject();
        _this.shouldLabelFloat = true;
        _this._disabled = false;
        _this._uid = "wa-codemirror-" + nextUniqueId++;
        if (_this.ngControl !== null) {
            _this.ngControl.valueAccessor = _this;
        }
        return _this;
    }
    Object.defineProperty(MatCodemirrorComponent.prototype, "value", {
        get: function () {
            return this.codemirror ? this.codemirror.getValue() : '';
        },
        set: function (value) {
            if (this.codemirror) {
                if (value !== this.value) {
                    this.codemirror.setValue(value);
                    this.stateChanges.next();
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MatCodemirrorComponent.prototype, "disabled", {
        get: function () {
            if (this.ngControl && this.ngControl.disabled !== null) {
                return this.ngControl.disabled;
            }
            return this._disabled;
        },
        set: function (disabled) {
            this._disabled = disabled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MatCodemirrorComponent.prototype, "id", {
        get: function () {
            return this._id;
        },
        set: function (id) {
            this._id = id || this._uid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MatCodemirrorComponent.prototype, "empty", {
        get: function () {
            return this.value !== '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MatCodemirrorComponent.prototype, "focused", {
        get: function () {
            if (this.codemirror) {
                return this.codemirror.hasFocus();
            }
            return false;
        },
        enumerable: true,
        configurable: true
    });
    MatCodemirrorComponent.prototype.ngOnChanges = function () {
        this.stateChanges.next();
    };
    MatCodemirrorComponent.prototype.ngDoCheck = function () {
        if (this.ngControl) {
            this.updateErrorState();
        }
    };
    MatCodemirrorComponent.prototype.ngOnDestroy = function () {
        this.stateChanges.complete();
    };
    MatCodemirrorComponent.prototype.onContainerClick = function (event) {
        this.focus();
    };
    MatCodemirrorComponent.prototype.focus = function () {
        if (this.codemirror) {
            this.codemirror.focus();
            this.stateChanges.next();
        }
    };
    MatCodemirrorComponent.prototype.updateErrorState = function () {
        var oldState = this.errorState;
        var parent = this._parentFormGroup || this._parentForm;
        var matcher = this.errorStateMatcher || this._defaultErrorStateMatcher;
        var control = this.ngControl ? (this.ngControl.control) : null;
        var newState = matcher.isErrorState(control, parent);
        if (newState !== oldState) {
            this.errorState = newState;
            this.stateChanges.next();
        }
    };
    MatCodemirrorComponent.prototype.setDescribedByIds = function (ids) {
    };
    return MatCodemirrorComponent;
}(ngCodemirror.CodemirrorComponent));
MatCodemirrorComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'wa-mat-codemirror',
                template: '',
                providers: [
                    {
                        provide: formField.MatFormFieldControl,
                        useExisting: MatCodemirrorComponent,
                    },
                ],
            },] },
];
MatCodemirrorComponent.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: core$1.ErrorStateMatcher, },
    { type: forms.NgForm, decorators: [{ type: core.Optional },] },
    { type: forms.FormGroupDirective, decorators: [{ type: core.Optional },] },
    { type: forms.NgControl, decorators: [{ type: core.Self }, { type: core.Optional },] },
    { type: undefined, decorators: [{ type: core.Inject, args: [ngCodemirror.WA_CODEMIRROR_DEFAULTS,] }, { type: core.Optional },] },
]; };
MatCodemirrorComponent.propDecorators = {
    "placeholder": [{ type: core.Input },],
    "required": [{ type: core.Input },],
    "errorStateMatcher": [{ type: core.Input },],
    "value": [{ type: core.Input },],
    "disabled": [{ type: core.Input },],
    "id": [{ type: core.Input },],
};
var MatCodemirrorModule = /** @class */ (function () {
    function MatCodemirrorModule() {
    }
    return MatCodemirrorModule;
}());
MatCodemirrorModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    ngCodemirror.CodemirrorModule,
                ],
                declarations: [
                    MatCodemirrorComponent,
                ],
                exports: [
                    ngCodemirror.CodemirrorModule,
                    MatCodemirrorComponent,
                ],
            },] },
];

exports.MatCodemirrorComponent = MatCodemirrorComponent;
exports.MatCodemirrorModule = MatCodemirrorModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=webacad-ng-mat-codemirror.umd.js.map
